/***************************************************
GENRE: An evolutionary design system.
Copyright (C) 1999-2003, Gregory S. Hornby.
hornby@email.arc.nasa.gov
http://ic.arc.nasa.gov/people/hornby

This library is free software; you can redistribute
it and/or modify it under the terms of the GNU Lesser
General Public License as published by the Free
Software Foundation; either version 2.1 of the License,
or (at your option) any later version.

This library is distributed in the hope that it will
be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

The text of the GNU Lesser General Public License is
included with this library in the file LICENSE.TXT.
If this file is not included with this library write
to the Free Software Foundation, Inc., 59 Temple Place,
Suite 330, Boston, MA  02111-1307  USA
****************************************************/

#ifndef QUAT_HEADER_FILE
#define QUAT_HEADER_FILE

#include "general.h"

typedef Real Quat[4];


void qt_print(Quat q, char *string);
void qt_make(Quat q, Real x, Real y, Real z, Real ang);
void qt_invert(Quat q_inv, Quat q);
Real qt_norm(Quat q);
void qt_normalize(Quat q);
void qt_mult(Quat q_d, Quat q1, Quat q2);
void qt_to_col_matrix(Real mat[4][4], Quat q);
void qt_to_row_matrix(Real mat[4][4], Quat q);
void qt_deriv(Quat dq, Real vang[3], Quat q);

#endif
